regina::NLayeredLoop Class Reference
Standard Triangulations and Subcomplexes

Represents a layered loop component of a triangulation. More...

`#include <subcomplex/nlayeredloop.h>`

Inheritance diagram for regina::NLayeredLoop:

## Public Member Functions

virtual | ~NLayeredLoop ()
| Destroys this layered loop. More...
NLayeredLoop * | clone () const
| Returns a newly created clone of this structure. More...
unsigned long | getLength () const
| Returns the length of this layered loop. More...
unsigned long | getIndex () const
| Returns the length of this layered loop. More...
bool | isTwisted () const
| Determines if this layered loop contains a twist. More...
NEdge * | getHinge (int which) const
| Returns the requested hinge edge of this layered loop. More...
NManifold * | getManifold () const
| Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented. More...
NAbelianGroup * | getHomologyH1 () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the name of this triangulation as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the name of this triangulation in TeX format to the given output stream. More...
void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
Public Member Functions inherited from regina::NStandardTriangulation
virtual | ~NStandardTriangulation ()
| A destructor that does nothing. More...
std::string | getName () const
| Returns the name of this specific triangulation as a human-readable string. More...
std::string | getTeXName () const
| Returns the name of this specific triangulation in TeX format. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes this object in short text format to the given output stream. More...
Public Member Functions inherited from regina::ShareableObject
| ShareableObject ()
| Default constructor that does nothing. More...
virtual | ~ShareableObject ()
| Default destructor that does nothing. More...
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...

## Static Public Member Functions

static NLayeredLoop * | isLayeredLoop (const NComponent *comp)
| Determines if the given triangulation component is a layered loop. More...
Static Public Member Functions inherited from regina::NStandardTriangulation
static NStandardTriangulation * | isStandardTriangulation (NComponent *component)
| Determines whether the given component represents one of the standard triangulations understood by Regina. More...
static NStandardTriangulation * | isStandardTriangulation (NTriangulation *tri)
| Determines whether the given triangulation represents one of the standard triangulations understood by Regina. More...

## Additional Inherited Members

Protected Member Functions inherited from regina::boost::noncopyable
| noncopyable ()
| A constructor which does nothing. More...
| ~noncopyable ()
| A destructor which does nothing. More...

## Detailed Description

Represents a layered loop component of a triangulation.

A layered loop is a layered chain of n tetrahedra whose bottom tetrahedron is layered onto its top tetrahedron to form a complete loop. See the NLayeredChain class notes for a description of a layered chain.

To make a layered chain into a layered loop, the bottom faces of the first tetrahedron will be layered upon the top faces of the last tetrahedron, completing the loop. At this stage there is a choice. The layering can be done in the usual fashion, or there may be a twist in which the upper square (the bottom faces of the first tetrahedron) is rotated 180 degrees before being layered on the lower annulus (the top faces of the last tetrahedron).

If there is a twist, the two hinge edges become identified and the entire component has a single vertex. If there is no twist, the two hinge edges remain distinct (and disjoint) and the entire component has two vertices.

The length of the layered loop is the number of tetrahedra it contains. A layered loop must contain at least one tetrahedron.

All optional NStandardTriangulation routines are implemented for this class.

Test:
  Included in the test suite.

## Constructor & Destructor Documentation

regina::NLayeredLoop::~NLayeredLoop | ( |  | ) |

inline virtual

Destroys this layered loop.

## Member Function Documentation

NLayeredLoop* regina::NLayeredLoop::clone | ( |  | ) | const

Returns a newly created clone of this structure.

Returns
  a newly created clone.

NEdge * regina::NLayeredLoop::getHinge | ( | int | which | ) | const

inline

Returns the requested hinge edge of this layered loop.

See the general class notes for further details. If there is only one hinge but parameter which is 1, `null` will be returned.

Parameters

  which | specifies which hinge to return; this must be 0 or 1.

Returns
  the requested hinge edge.

NAbelianGroup* regina::NLayeredLoop::getHomologyH1 | ( |  | ) | const

virtual

Returns the expected first homology group of this triangulation, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this triangulation then this routine will return 0.

This routine does not work by calling NTriangulation::getHomologyH1() on the associated real triangulation. Instead the homology is calculated directly from the known properties of this standard triangulation.

The details of which standard triangulations have homology calculation routines can be found in the notes for the corresponding subclasses of NStandardTriangulation. The default implementation of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

If this NStandardTriangulation describes an entire NTriangulation (and not just a part thereof) then the results of this routine should be identical to the homology group obtained by calling NTriangulation::getHomologyH1() upon the associated real triangulation.

Returns
  the first homology group of this triangulation, or 0 if the appropriate calculation routine has not yet been implemented.

Reimplemented from regina::NStandardTriangulation.

unsigned long regina::NLayeredLoop::getIndex | ( |  | ) | const

inline

Returns the length of this layered loop.

See the general class notes for further details.

Deprecated:
  The preferred way of accessing the length of a layered loop is through getLength().

Returns
  the length of this layered loop.

unsigned long regina::NLayeredLoop::getLength | ( |  | ) | const

inline

Returns the length of this layered loop.

See the general class notes for further details.

Returns
  the length of this layered loop.

NManifold* regina::NLayeredLoop::getManifold | ( |  | ) | const

virtual

Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented.

If the 3-manifold cannot be recognised then this routine will return 0.

The details of which standard triangulations have 3-manifold recognition routines can be found in the notes for the corresponding subclasses of NStandardTriangulation. The default implementation of this routine returns 0.

It is expected that the number of triangulations whose underlying 3-manifolds can be recognised will grow between releases.

The 3-manifold will be newly allocated and must be destroyed by the caller of this routine.

Returns
  the underlying 3-manifold.

Reimplemented from regina::NStandardTriangulation.

static NLayeredLoop* regina::NLayeredLoop::isLayeredLoop | ( | const NComponent * | comp | ) |

static

Determines if the given triangulation component is a layered loop.

Parameters

  comp | the triangulation component to examine.

Returns
  a newly created structure containing details of the layered loop, or `null` if the given component is not a layered loop.

bool regina::NLayeredLoop::isTwisted | ( |  | ) | const

inline

Determines if this layered loop contains a twist.

See the general class notes for further details.

Returns
  `true` if and only if this layered loop contains a twist.

std::ostream & regina::NLayeredLoop::writeName | ( | std::ostream & | out | ) | const

inline virtual

Writes the name of this triangulation as a human-readable string to the given output stream.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NStandardTriangulation.

std::ostream & regina::NLayeredLoop::writeTeXName | ( | std::ostream & | out | ) | const

inline virtual

Writes the name of this triangulation in TeX format to the given output stream.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NStandardTriangulation.

void regina::NLayeredLoop::writeTextLong | ( | std::ostream & | out | ) | const

inline virtual

Writes this object in long text format to the given output stream.

The output should provide the user with all the information they could want. The output should be human-readable, should not contain extremely long lines (so users can read the output in a terminal), and should end with a final newline.

The default implementation of this routine merely calls writeTextShort() and adds a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Reimplemented from regina::ShareableObject.

The documentation for this class was generated from the following file:

- subcomplex/nlayeredloop.h

Copyright © 1999-2013, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).